﻿using System;
using System.Collections.Generic;
using System.Linq;
//using System.Web.Http
using System.Web;
using System.Web.Mvc;
using SyncfusionMvcApplication33;
using SyncfusionMvcApplication33.Models;
namespace SyncfusionMvcApplication33.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            var DataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datasource = DataSource;            
            return View();
        }

        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            var DataSource = OrderRepository.GetAllRecords();
            DataResult result = new DataResult();
            result.result = DataSource.Skip(dm.Skip).Take(dm.Take).ToList();
            result.count = DataSource.Count();
           // if(exception occurs)
           HttpContext.Response.AddHeader("Exception", "Our Exception message");
           Response.StatusCode = 404; //set failure in request.
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable<EditableOrder> result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            
            OrderRepository.Update(value);
            //if()code to check backend data fails or not
            Response.StatusCode = 404; // if fails  put this code
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {

            OrderRepository.Add(value);
            //if()code to check backend data fails or not
            Response.StatusCode = 404; // if fails  put this code
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            //if()code to check backend data fails or not
            Response.StatusCode = 404; // if fails  put this code
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}
